<?php
/////////////////////////////////////////////////////////////////
// FILENAME  : stats.php
// COPYRGIHT : (C) 2005, Invader
// WWW       : N/A
/////////////////////////////////////////////////////////////////
define ( IN_PHPBB, true );
$phpbb_root_path	= './';
include ( $phpbb_root_path . 'extension.inc' );
include ( $phpbb_root_path . 'common.'.$phpEx );

$userdata = session_pagestart ( $user_ip, PAGE_INDEX );
init_userprefs ( $userdata );
include ( $phpbb_root_path . 'includes/page_header.'.$phpEx );

$mode		= intval ( $_GET[ 'mode' ] );
$look_up	= $_POST[ 'player' ];
$pp		= 50;
$socket		= $_POST[ 'socket' ];

$lang[ 'stats_find' ]	= 'Find a Player';
$lang[ 'stats_high' ]	= 'High Scores';
$lang[ 'stats_ladder' ]	= 'Ladder';
$lang[ 'stats_wonr' ]	= 'Won Rounds';
$lang[ 'stats_wonm' ]	= 'Won Matches';
$lang[ 'stats_socket' ]	= 'Socket Grab (URL)';

function get_stats ( $url )
{
	$url_parsed	= parse_url ( $url );
	$host		= $url_parsed[ 'host' ];
	$port		= $url_parsed[ 'port' ];

	if ( $port == 0 )
	{
		$port	= 80;
	}

	$path	= $url_parsed[ 'path' ];

	if ( $url_parsed[ 'query' ] != '' )
	{
		$path	.= '?' . $url_parsed[ 'query' ];
	}

	$out	= "GET $path HTTP/1.0\r\nHost: $host\r\n\r\n";
	$socket	= fsockopen ( $host, $port, $errno, $errstr, 30 );
	fwrite ( $socket, $out );
	$data	= '';

	while ( !feof ( $socket ) )
	{
		$data	.= fgets ( $socket, 128 );
	}
	fclose ( $socket );

	if ( is_file ( 'socket.txt' ) )
	{
		unlink ( 'socket.txt' );
	}

	$download	= fopen ( 'socket.txt', 'x+' );
	fwrite ( $download, $data );
	fclose ( $download );

	$file	= file ( 'socket.txt' );
	$temp	= file_get_contents ( 'socket.txt' );

	foreach ( $file AS $line => $lines )
	{
		if ( $line == 0 || $line == 1 || $line == 2 || $line == 3 || $line == 4 || $line == 5 || $line == 6 || $line == 7 || $line == 8 || $line == 9 )
		{
			$temp	= str_replace ( $lines, '', $temp );
		}
		else
		{
			break;
		}
	}
	unlink ( 'socket.txt' );

	$refined	= fopen ( 'socket.txt', 'x+' );
	fwrite ( $refined, $temp );
	fclose ( $refined );

	return file_get_contents ( 'socket.txt' );
}

if ( empty ( $socket ) )
{
	$file_array	= array (
		'./highscores.txt',
		'./ladder.txt',
		'./won_rounds.txt',
		'./won_matches.txt',
	);

	foreach ( $file_array AS $file )
	{
		preg_match_all ( '#(\d+)\s+(.*)#', file_get_contents ( $file ), $result );
		unset ( $result[ 0 ] );

		$result_3	= array ( );
		$total = sizeof ( $result[ 1 ] );

		for ( $i = 0; $i < $total; $i++ )
		{
			$result_3[ $result[ 2 ][ $i ] ]	= $result[ 1 ][ $i ];
		}

		if ( $file == './ladder.txt' )
		{
			//sort ( $result_3 );
		}

		$file_modified	= str_replace ( array ( './', '.txt' ), '', $file );
		$file_modified	= str_replace ( '_', ' ', $file_modified );

		$template->assign_block_vars ( 'block_table', array (
			'S_FILE' => strtoupper ( $file_modified ) )
		);

		$count		= 1;
		foreach ( $result_3 AS $key => $value )
		{
			if ( $count++ > $pp )
			{
				break;
			}
			else
			{
				if ( !empty ( $look_up ) && strtolower ( $key ) == strtolower ( $look_up ) )
				{
					$template->assign_block_vars ( 'block_player', array (
						'S_KEY' => $key,
						'S_VALUE' => $value,
						'S_FILE' => strtoupper ( $file_modified ) )
					);
				}

				$template->assign_block_vars ( 'block_table.block_data', array (
					'S_KEY' => $key,
					'S_VALUE' => $value )
				);
			}
		}
	}

	$template->assign_vars ( array (
		'S_ACTION' => append_sid ( 'stats.php' ),
		'L_FIND' => $lang[ 'stats_find' ],
		'L_HIGHSCORES' => $lang[ 'stats_high' ],
		'L_LADDER' => $lang[ 'stats_ladder' ],
		'L_WONR' => $lang[ 'stats_wonr' ],
		'L_WONM' => $lang[ 'stats_wonm' ] )
	);

	$template->set_filenames ( array (
		'body' => 'stats.tpl' )
	);
	$template->pparse ( 'body' );
}
else
{
	preg_match_all ( '#(\d+)\s+(.*)#', get_stats ( $socket ), $result );
	unset ( $result[ 0 ] );

	$result_3	= array ( );
	$total = sizeof ( $result[ 1 ] );

	for ( $i = 0; $i < $total; $i++ )
	{
		$result_3[ $result[ 2 ][ $i ] ]	= $result[ 1 ][ $i ];
	}

	$code		= '';
	$count		= 1;
	foreach ( $result_3 AS $key => $value )
	{
		if ( $count++ > $pp )
		{
			break;
		}
		else
		{
			if ( !empty ( $look_up ) && strtolower ( $key ) == strtolower ( $look_up ) )
			{
				$template->assign_block_vars ( 'block_player', array (
					'S_KEY' => $key,
					'S_VALUE' => $value )
				);
			}

			$code	.= '
	<tr class="genmed">
		<td class="row2" width="10%"><b>' . $value . '</b></td>
		<td class="row2">' . $key . '</td>
	</tr>';
		}
	}

	$template->assign_vars ( array (
		'S_ACTION' => append_sid ( 'stats.php' ),
		'L_FIND' => $lang[ 'stats_find' ],
		'S_SOCKET' => $socket,
		'S_CODE' => $code,
		'L_SOCKET' => $lang[ 'stats_socket' ] )
	);

	$template->set_filenames ( array (
		'body' => 'stats_socket.tpl' )
	);
	$template->pparse ( 'body' );
}

include ( $phpbb_root_path . 'includes/page_tail.'.$phpEx );
?>